---------------------------------------------------------------------
--== Import ===--
---------------------------------------------------------------------

import "Turbine.Gameplay"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Souru.LootLogs.Type"
import "Souru.LootLogs.Class"
import "Souru.LootLogs.UI"

---------------------------------------------------------------------
--==  ===--
---------------------------------------------------------------------

me = Turbine.Gameplay.LocalPlayer:GetInstance()
myName = me:GetName()

window = nil
icon = nil

classIcon = {

	[ Turbine.Gameplay.Class.Hunter ]     = 0x41007dea, --0x410000E8 --0x41007DDA --0x41008201 --0x410095C2                 --0x41108678
	[ Turbine.Gameplay.Class.Warden ]     = 0x410ea239, --0x410095C5 --0x410EA237                                           --0x410F25C2
	[ Turbine.Gameplay.Class.Burglar ]    = 0x41007deb, --0x410000E4 --0x41007DDB --0x41007E87 --0x410095BB                 --0x41108674
	[ Turbine.Gameplay.Class.Captain ]    = 0x41007de7, --0x410000E5 --0x41007DD7 --0x410081F3 --0x410095C5                 --0x41108675
	[ Turbine.Gameplay.Class.Champion ]   = 0x41007dec, --0x410000E6 --0x41007DDC --0x410081CD --0x410095B5                 --0x41108676
	[ Turbine.Gameplay.Class.Guardian ]   = 0x41007de8, --0x410000E7 --0x41007DD8 --0x410081FF --0x410095B8                 --0x41108677
	[ Turbine.Gameplay.Class.Minstrel ]   = 0x41007de6, --0x410000E9 --0x41007DD6 --0x41004C49 --0x410081F7                 --0x4110867A
	[ Turbine.Gameplay.Class.Beorning ]   = 0x4115370d,
	[ Turbine.Gameplay.Class.LoreMaster ] = 0x41007de9, --0x410000E9 --0x41007DD9 --0x410081FC --0x410095BF                 --0x41108679
	[ Turbine.Gameplay.Class.RuneKeeper ] = 0x410ea238, --0x410E6BF4 --0x410EA236                                           --0x4110867B
	[ Turbine.Gameplay.Class.Brawler ]    = 0x411F516F, --1092680920

	[ Turbine.Gameplay.Class.Weaver ]     = 0x41007DEE, --0x41007DE0 --0x41007DCA
	[ Turbine.Gameplay.Class.Reaver ]     = 0x41007DED, --0x41007DDD --0x41007DC9
	[ Turbine.Gameplay.Class.Defiler ]    = 0x410E6BF4, --0x410E6BF5 --0x410E6BF4
	[ Turbine.Gameplay.Class.Stalker ]    = 0x41007DF1, --0x41007DE1 --0x41007DCD
	[ Turbine.Gameplay.Class.WarLeader ]  = 0x41007DF0, --0x41007DDD --0x41007DCC
	[ Turbine.Gameplay.Class.BlackArrow ] = 0x41007DEF  --0x41007DDF --0x41007DCB

	--ty miniraid :3
}

---------------------------------------------------------------------
--== localization ===--
---------------------------------------------------------------------

local locale = "en"
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
	import "Souru.LootLogs.Localization.de"
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
	import "Souru.LootLogs.Localization.fr"
else
	import "Souru.LootLogs.Localization.en"
end

---------------------------------------------------------------------
--== Basic Functions ===--
---------------------------------------------------------------------

Size_item = Turbine.UI.Control()

function GetImageSize(id)
	Size_item:SetBackground(id)
	Size_item:SetStretchMode(2)
	Turbine.Shell.WriteLine(Size_item:GetWidth())
	return Size_item:GetSize()
end

function SaveLogs()

	LootList["locale"] = locale
	if locale == "en" then
		Turbine.PluginData.Save(Turbine.DataScope.Account, "LootLogsNew", LootList)
	else
		Turbine.PluginData.Save(Turbine.DataScope.Account, "LootLogsNew", convertToEuro(LootList))
	end

end

function SaveSettings()

	LootSettings["locale"] = locale
	if locale == "en" then
		Turbine.PluginData.Save(Turbine.DataScope.Character, "LootSettingsNew", LootSettings)
	else
		Turbine.PluginData.Save(Turbine.DataScope.Character, "LootSettingsNew", convertFromEuro(LootSettings))
	end
	

end

function CheckForMe()

	for bossindex,v in ipairs(LootList) do 
		
		if v["name"] == myName then
			return bossindex
		end
		
	end
	
	return nil

end

function AddMe()

	local index = table.getn(LootList)+1
	
	LootList[index] = {}
	LootList[index]["name"] = myName
	LootList[index]["class"] = me:GetClass()
	LootList[index]["loot"] = {}
	
	currentIndex = index
	
	SaveLogs()

end

function CheckForReset()

	local gt = Turbine.Engine.GetGameTime()

	for pIndex, player in ipairs(LootList) do

		local contentCounter = 0

		for cIndex, content in ipairs(_G.Instances) do

			if player["loot"][cIndex] ~= nil then

				local iniCounter = 0

				for iIndex, ini in ipairs(content["instances"]) do

					if player["loot"][cIndex][iIndex] ~= nil then

						local tierCounter = 0

						for tIndex, tier in ipairs(ini) do

							if player["loot"][cIndex][iIndex][tIndex] ~= nil then

								local bossCounter = 0

								for bIndex, boss in ipairs(tier) do

									if player["loot"][cIndex][iIndex][tIndex][bIndex] ~= nil then

										if player["loot"][cIndex][iIndex][tIndex][bIndex]["reset"] <= gt then

											if boss.only_reset_if_done ~= true then

												player["loot"][cIndex][iIndex][tIndex][bIndex] = nil

											else

												if player["loot"][cIndex][iIndex][tIndex][bIndex]["value"] == _G.Done then

													player["loot"][cIndex][iIndex][tIndex][bIndex] = nil

												else

													contentCounter = contentCounter + 1
													iniCounter = iniCounter + 1
													tierCounter = tierCounter + 1
													bossCounter = bossCounter + 1

												end

											end

										else 

											contentCounter = contentCounter + 1
											iniCounter = iniCounter + 1
											tierCounter = tierCounter + 1
											bossCounter = bossCounter + 1

										end
		
									end
		
								end

								if bossCounter == 0 then

									player["loot"][cIndex][iIndex][tIndex] = nil

								end

							end

						end

						if tierCounter == 0 then

							player["loot"][cIndex][iIndex] = nil

						end

					end

				end

				if iniCounter == 0 then

					player["loot"][cIndex] = nil

				end

			end

		end

		if contentCounter == 0 then

			player["loot"] = {}

		end

	end

	SaveLogs()

end

function ResetToString(resetTime)

	local reset = (resetTime-Turbine.Engine.GetGameTime())/3600
	local returnString = math.floor(reset/24)
	reset = reset-(returnString*24)
	returnString = returnString.."d - "..math.floor(reset).."h"

	return returnString

end

function ClearSaveFile()

	LootList = nil
	LootList = {}
	AddMe()
	SaveLogs()

end

function convertToEuro(dataRaw)
	local newData = {};
	for i, myData in pairs(dataRaw) do
		local tempIndex = nil;
		local tempData = nil;
		if (type(i) == "number") then
			tempIndex = tostring(i);
		else
			tempIndex = i;
		end
		if (type(myData) == "table") then
			tempData = convertToEuro(myData);
		elseif (type(myData) == "number") then
			tempData = tostring(myData);
		else
			tempData = myData;
		end
		newData[tempIndex] = tempData;
	end
	return newData;
end

function convertFromEuro(dataRaw)
	local newData = {}
	for i, myData in pairs(dataRaw) do
		local tempIndex = tonumber(i);
		if (tempIndex == nil) then
			tempIndex = i;
		end
		local tempData = nil;

		if (type(myData) == "table") then
			tempData = convertFromEuro(myData);
		else
			tempData = tonumber(myData);
			if (tempData == nil) then
				tempData = myData;
			end
		end
		newData[tempIndex] = tempData;
	end
	return newData;
	
end

---------------------------------------------------------------------
--== UI Functions ===--
---------------------------------------------------------------------

function OpenSettings()
	if  window == nil then
		CheckForReset()
		window = UI.Window()
	else
		window:Close()
	end
end

function ShowBossName(bool, text, left, top)

	if  window ~= nil then
		window:ShowBossName(bool, text, left, top)
	end
end

function LootUpdatedSettings()
	if  window ~= nil then
		window:LootUpdatedSettings()
	end
end

function CloseSettings()
	window = nil
end

---------------------------------------------------------------------
--== Load ===--
---------------------------------------------------------------------

locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
end

if Turbine.PluginData.Load(Turbine.DataScope.Character, "LootSettingsNew") ~= nil then

	LootSettings = Turbine.PluginData.Load(Turbine.DataScope.Character, "LootSettingsNew")
	if LootSettings["locale"] ~= "en" and LootSettings["locale"] ~= nil then
		LootSettings = convertFromEuro(LootSettings);
	end

	if LootSettings["show_notifications"] == nil then
		LootSettings["show_notifications"] = true
	end

else

	LootSettings = {}

	LootSettings["window"] = {}
	LootSettings["window"]["left"] = 500
	LootSettings["window"]["top"] = 500
	LootSettings["window"]["width"] = 850
	LootSettings["window"]["height"] = 500
	LootSettings["icon"] = {}
	LootSettings["icon"]["left"] = 200
	LootSettings["icon"]["top"] = 200
	LootSettings["icon"]["move"] = true

end 

if Turbine.PluginData.Load(Turbine.DataScope.Account, "LootLogsNew") ~= nil then

	LootList = Turbine.PluginData.Load(Turbine.DataScope.Account, "LootLogsNew")
	if LootList["locale"] ~= "en" and LootList["locale"] ~= nil then

		LootList = convertFromEuro(LootList);
	end

	currentIndex = CheckForMe()
	
	if currentIndex == nil then
		AddMe()
	else
		if LootList[currentIndex]["class"] == nil then
			LootList[currentIndex]["class"] = me:GetClass()
		end
	end
	
else

	LootList = {}

	AddMe()

	SaveLogs()

end



---------------------------------------------------------------------
--== Icon ===--
---------------------------------------------------------------------

icon = UI.WindowIcon()

---------------------------------------------------------------------
--== Loot Functions ===--
---------------------------------------------------------------------

resetTime = 9

function CalcNextReset(instanceObject)

	local date = Turbine.Engine.GetDate()
	local nextResetDay = nil
	local timeUntilReset = 60-date["Minute"]
	local hour = date["Hour"] + 1

	if(hour <= resetTime) then

		timeUntilReset = timeUntilReset + ((resetTime - hour)*60)
		nextResetDay = date["DayOfWeek"]

	else

		timeUntilReset = timeUntilReset + ((resetTime + 24 - hour)*60)
		nextResetDay = (date["DayOfWeek"] + 1) % 8

		if nextResetDay == 0 then
			nextResetDay = 1
		end

	end

	local counter = 0
	while (instanceObject["reset"][nextResetDay] == false)do

		counter = counter + 1
		nextResetDay = (nextResetDay + 1) % 8

		if nextResetDay == 0 then
			nextResetDay = 1
		end

	end

	timeUntilReset = ( timeUntilReset + (counter * 24 * 60) ) * 60

	return math.floor(timeUntilReset + Turbine.Engine.GetGameTime())
	
end

function FindChest(message, value)

	for contentIndex, content in ipairs(_G.Instances) do

		for instanceIndex, instance in ipairs(content["instances"]) do

			for tierIndex, tier in ipairs(instance) do

				for bossIndex, chest in ipairs(tier) do

					if string.find(message, chest["text"]) then

						if LootList[currentIndex]["loot"][contentIndex] == nil then
							LootList[currentIndex]["loot"][contentIndex] = {}
						end

						if LootList[currentIndex]["loot"][contentIndex][instanceIndex] == nil then
							LootList[currentIndex]["loot"][contentIndex][instanceIndex] = {}
						end

						if LootList[currentIndex]["loot"][contentIndex][instanceIndex][tierIndex] == nil then
							LootList[currentIndex]["loot"][contentIndex][instanceIndex][tierIndex] = {}
						end

						if LootList[currentIndex]["loot"][contentIndex][instanceIndex][tierIndex][bossIndex] == nil then
							LootList[currentIndex]["loot"][contentIndex][instanceIndex][tierIndex][bossIndex] = {}
						end

						LootList[currentIndex]["loot"][contentIndex][instanceIndex][tierIndex][bossIndex]["value"] = value
						LootList[currentIndex]["loot"][contentIndex][instanceIndex][tierIndex][bossIndex]["reset"] = CalcNextReset(_G.Instances[contentIndex]["instances"][instanceIndex][tierIndex])
						LootUpdatedSettings()
						SaveLogs()

						local notification_text = "<rgb=#ffa500>"..instance["name"].."</rgb> <rgb=#FF0000>"..tier["name"].."</rgb> has been Updated."
						icon:AddNotification(notification_text)

					end

				end

			end

		end

	end

end

function split(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end

function CheckIfFinished(value)

	list = split(value, "/")

	if list[1] == list[2] then
		return _G.Done
	else
		return value
	end

end

function FindQuestAdvancement(text)

	if string.find(text, "%(%d+/%d+%)") then

		return CheckIfFinished(string.sub(text, string.find(text, "%(%d+/%d+%)")+1, string.len(text)-1))

	end

	return _G.Done

end

function Turbine.Chat.Received(sender, args)

	if args.ChatType == 21 or args.ChatType == Turbine.ChatType.Standard then

		if (string.find(args.Message, _G.Ini_FavoredCompletions)) ~= nil then -- FAVORED

			FindChest(string.sub(args.Message, 0, string.find(args.Message, _G.Ini_FavoredCompletions)), tonumber(string.match(string.sub(args.Message, string.find(args.Message,  _G.Ini_FavoredCompletions)) , "%d+")))

		elseif (string.find(args.Message, _G.Ini_Completions)) ~= nil then -- COMON
		
			FindChest(string.sub(args.Message, 0, string.find(args.Message, _G.Ini_Completions)), tonumber(string.match(string.sub(args.Message, string.find(args.Message, _G.Ini_Completions)) , "%d+"))*(-1))

		elseif (string.find(args.Message, _G.Ini_ResetIn)) ~= nil then -- RESET

			FindChest(string.sub(args.Message, 0, string.find(args.Message, _G.Ini_ResetIn)), 0)

		elseif (string.find(args.Message,_G.Quest_Completed)) ~= nil then -- QUESTS

			FindChest(args.Message, FindQuestAdvancement(args.Message))

		end

	end

end
